<?php

add_filter('wpcf7_spam', 'oopspamantispam_cf7_pre_submission', 10, 1);

function oopspamantispam_cf7_pre_submission($spam)
{

    $options = get_option('oopspamantispam_settings');

    if (!empty($options['oopspam_api_key']) && !empty($options['oopspam_is_cf7_activated'])) {

        if ($spam) {
            return $spam;
        }

        $userIP = "";
        $email = "";
        if (!isset($options['oopspam_is_check_for_ip']) || $options['oopspam_is_check_for_ip'] != true) {
            $userIP = oopspamantispam_get_ip();
        }

        if (isset($_POST["your-email"])) {
            $email = sanitize_email($_POST["your-email"]);
        }

        // This is default ID, set by CF7
        $customContentFieldId = "your-message";

        if (isset($options['oopspam_is_cf7_content_field']) && $options['oopspam_is_cf7_content_field']) {
            $customContentFieldId = sanitize_text_field(trim($options['oopspam_is_cf7_content_field']));
        }

        $escapedMsg = sanitize_textarea_field($_POST[$customContentFieldId]);
        $detectionResult = oopspamantispam_call_OOPSpam($escapedMsg, $userIP, $email, true);
        $raw_entry = json_encode($_POST);

        if (!isset($detectionResult["isItHam"])) {
            return $spam;
        }

        $frmEntry = [
            "Score" => $detectionResult["Score"],
            "Message" => $escapedMsg,
            "IP" => $userIP,
            "Email" => $email,
            "RawEntry" => $raw_entry,
            "FormId" => $_POST['_wpcf7'],
        ];

        if (!$detectionResult["isItHam"]) {

            // It's spam, store the submission and log it
            oopspam_store_spam_submission($frmEntry);

            $spam = true;

            // Leaving a spam log.
            $submission = WPCF7_Submission::get_instance();

            $submission->add_spam_log(array(
                'agent' => 'OOPSpam',
                'reason' => "OOPSpam score " . $detectionResult["Score"] . " is higher than the threshold " . oopspamantispam_get_spamscore_threshold(),
            ));
        } else {
            // It's ham
            oopspam_store_ham_submission($frmEntry);
        }
    }

    return $spam;
}
