<?php
add_filter('gform_validation', 'oopspamantispam_gform_pre_submission');

function oopspamantispam_gform_pre_submission($validation_result)
{
    $options = get_option('oopspamantispam_settings');

    $form = $validation_result["form"];
    $entry = GFFormsModel::get_current_lead();
    $raw_entry = json_encode($entry);
    $message = "";
    $selectedField = "";
    $email = "";

    // Check if a custom Field ID is set
    if (isset($options['oopspam_gf_content_field']) && $options['oopspam_gf_content_field']) {
        $nameOfTextareaField = sanitize_text_field(trim($options['oopspam_gf_content_field']));
        $message = $entry[$nameOfTextareaField];
        foreach ($form['fields'] as $field) { // Field settings, including the field key and value.
            // Capture the email
            if ('email' == $field['type']) {
                $email_field_id = "input_" . $field['id'];
                $email = sanitize_email(rgpost($email_field_id));
            }
            ;
            if ($nameOfTextareaField == $field['id']) {
                $selectedField = $field;
            }
            ;
        }
    } else {
        foreach ($form['fields'] as $field) {
            // Capture the email
            if ('email' == $field['type']) {
                $email_field_id = "input_" . $field['id'];
                $email = sanitize_email(rgpost($email_field_id));
            }
            ;
            if ('textarea' != $field['type']) {
                continue;
            }

            $field_id = "input_" . $field['id'];
            $message = rgpost($field_id);
            $selectedField = $field;
        }
    }

    if (!empty($options['oopspam_api_key']) && !empty($options['oopspam_is_gf_activated'])) {

        $escapedMsg = sanitize_textarea_field($message);
        $userIP = "";

        if (!isset($options['oopspam_is_check_for_ip']) || $options['oopspam_is_check_for_ip'] != true) {
            $userIP = $entry["ip"];
        }

        $detectionResult = oopspamantispam_call_OOPSpam($escapedMsg, $userIP, $email, true);
        if (!isset($detectionResult["isItHam"])) {
            return $validation_result;
        }

        $frmEntry = [
            "Score" => $detectionResult["Score"],
            "Message" => $escapedMsg,
            "IP" => $userIP,
            "Email" => $email,
            "RawEntry" => $raw_entry,
            "FormId" => $entry["form_id"],
        ];

        if (!$detectionResult["isItHam"]) {

            // It's spam, store the submission and show error
            oopspam_store_spam_submission($frmEntry);

            $error_to_show = $options['oopspam_gf_spam_message'];
            $validation_result["is_valid"] = false;

            if (empty($selectedField)) {
                $selectedField = $form['fields'][0];
            }

            $selectedField->failed_validation = true;
            $selectedField->validation_message = $error_to_show;
        } else {
            // It's ham
            oopspam_store_ham_submission($frmEntry);
        }
        $validation_result['form'] = $form;
        return $validation_result;
    }
    return $validation_result;
}
