<?php

add_filter( 'piotnetforms/form_builder/validate_pre_submit_form', 'oopspamantispam_pionetf_pre_submission', 10, 4 );



function oopspamantispam_pionetf_pre_submission($custom_message, $fields, $form, $form_id)
{

    $options = get_option('oopspamantispam_settings');
    $message = "";
    $email = "";

    if (empty($fields)) {
        return;
    }

    // Check if a custom Field ID is set
    if (isset($options['oopspam_pionet_content_field']) && $options['oopspam_pionet_content_field']) {
        $nameOfTextareaField = sanitize_text_field(trim($options['oopspam_pionet_content_field']));
        foreach ($fields as $field) {
            if ($field["name"] == $nameOfTextareaField) {
                $message = $field["value"];
            }
            // FIX: Pionet Forms has a bug where 'type' field is missing in textarea fields
            if (isset($field["type"]) && $field["type"] == "email") {
                $email = sanitize_email($field["value"]);
            }
        }
    } else {
        // Attempt to find textarea field name
        foreach ($fields as $field) {
            if (isset($field["type"]) && $field["type"] == "textarea") {
                $message = $field["value"];
            }
            if (isset($field["type"]) && $field["type"] == "email") {
                $email = sanitize_email($field["value"]);
            }
        }
    }

    if (!empty($options['oopspam_api_key']) && !empty($options['oopspam_is_pionet_activated'])) {

        $userIP = "";
        if (!isset($options['oopspam_is_check_for_ip']) || $options['oopspam_is_check_for_ip'] != true) {
            $userIP = oopspamantispam_get_ip();
        }
        $escapedMsg = sanitize_textarea_field($message);
        $raw_entry = json_encode($fields);
        $detectionResult = oopspamantispam_call_OOPSpam($escapedMsg, $userIP, $email, true);
        if (!isset($detectionResult["isItHam"])) {
            return;
        }
        $frmEntry = [
            "Score" => $detectionResult["Score"],
            "Message" => $escapedMsg,
            "IP" => $userIP,
            "Email" => $email,
            "RawEntry" => $raw_entry,
            "FormId" => $form_id,
        ];

        if (!$detectionResult["isItHam"]) {

            // It's spam, store the submission and show error
            oopspam_store_spam_submission($frmEntry);
            $error_to_show = $options['oopspam_pionet_spam_message'];
            return $error_to_show;
        } else {
            // It's ham
            oopspam_store_ham_submission($frmEntry);
            return;
        }

    }

    return;
}
